define(['mui', "mui.poppicker", 'util', "global", "api"], function(mui, poppicker, util, global, api) {
	var picker = {}; //选择器

	var SaveLogin = function(data) {
		//保存登录信息
		localStorage.setItem("LoginMemberInfo", JSON.stringify(data));
		localStorage.setItem(global.ID, data.ID);
	}

	//获取登录信息[返回JSON]
	var GetLogin = function() {

		var info = localStorage.getItem("LoginMemberInfo");
		if (info == null) {
			return null;
		}
		return JSON.parse(info);
	}

	//获取登录ID
	var GetLoginID = function() {
		return localStorage.getItem(global.ID) ? localStorage.getItem(global.ID) : "";
	}
 
	//退出账号
	var ExitLogin = function() {
		//localStorage.clear();
		localStorage.removeItem("LoginMemberInfo");
		localStorage.removeItem(global.ID);

	}

	//不传参数则返回整个JSON对象
	var getPaperworkType = function(_value) {
		var json = [{
			value: '1',
			text: '二代身份证'
		}, {
			value: '2',
			text: '港澳通行证'
		}, {
			value: '3',
			text: '台湾通行证'
		}, {
			value: '4',
			text: '护照'
		}];
		if (_value != null) {
			for (var i = 0; i < json.length; i++) {
				if (json[i].value == _value) {
					return json[i].text;
				}
			}
			return "";
		}

		//获取证件类型
		return json;
	}

	var getTimeNode = function() {

			//		var myDate = new Date();
			//		var h  = myDate.getHours()+1;
			//		var timeJson = [];
			//		for	(var i = h;i < 23;i++)
			//		{
			//			
			//			timeJson.push({
			//				value: 'h'+i,
			//				text: i+':00-'+(i+1)+':00'
			//			});
			//		}
			//		
			//		return timeJson;
			return [{
				value: 'ywj',
				text: '6:00-7:00'
			}, {
				value: 'aaa',
				text: '7:00-8:00'
			}, {
				value: 'lj2',
				text: '8:00-9:00'
			}, {
				value: 'ymt',
				text: '9:00-10:00'
			}, {
				value: 'ymt2',
				text: '10:00-11:00'
			}, {
				value: 'shq3',
				text: '11:00-12:00'
			}, {
				value: 'shq4',
				text: '12:00-13:00'
			}, {
				value: 'shq5',
				text: '13:00-14:00'
			}, {
				value: 'shq6',
				text: '14:00-15:00'
			}, {
				value: 'shq7',
				text: '15:00-16:00'
			}, {
				value: 'shq8',
				text: '16:00-17:00'
			}, {
				value: 'shq9',
				text: '17:00-18:00'
			}, {
				value: 'shq10',
				text: '18:00-19:00'
			}, {
				value: 'shq11',
				text: '19:00-20:00'
			}, {
				value: 'shq21',
				text: '20:00-21:00'
			}, {
				value: 'shq22',
				text: '21:00-22:00'
			}, {
				value: 'shq23',
				text: '22:00-23:00'
			}];
		}
		//选择器
		//_type = zj = 证件类型
		//_mp = 套餐类型的数据源
	var showPicker = function(_type, onshow, _mp) {
		mui("input").each(function() {
			this.blur();
		})
		switch (_type) {
			case "zj":
				if (picker[_type] == null) {
					picker[_type] = new mui.PopPicker();
					picker[_type].setData(getPaperworkType()); //初始化
				}
				break;
			case "time": //时间段选择器
				if (picker[_type] == null) {
					picker[_type] = new mui.PopPicker();
					picker[_type].setData(getTimeNode()); //初始化
				}
				break;
			case "site":
				if (picker[_type] == null) {
					picker[_type] = new mui.PopPicker();
					picker[_type].setData(get_site_source()); //初始化
				}
				break;
			case "date":
				if (!picker[_type]) {
					 
					picker[_type] = new mui.DtPicker({
						type: "date",
						beginYear: 2016,
						endYear: 2017
					});
				}
				break;
			case "mp":
				if (!_mp) {
					return;
				}
				if (picker[_type] == null) {
					var mpData = [];
					mpData.push({
						value: "",
						text: "不选择",
						Name: "无",
						SurplusCount: 0
					});
					for (i in _mp) {
						mpData.push({
							value: _mp[i].ID,
							text: _mp[i].Name + "：" + _mp[i].SurplusCount + "次",
							Name: _mp[i].Name,
							SurplusCount: _mp[i].SurplusCount
						});
					}
					picker[_type] = new mui.PopPicker();
					picker[_type].setData(mpData); //初始化
				}
				break;
			default:
				mui.toast("没有该选择器~");
				return;

		}
		picker[_type].show(onshow);
	}

	//比较两个时间大小。
	//_t1 = 时间
	//_t2 = 时间2（不传入时则获取当前时间）
	//_t1 > _t2 时 则返回 true
	var compTime = function(_t1, _t2) {
		if (_t1 == null) {
			return false;
		}
		_t1 = new Date(_t1.replace("-", "/").replace("-", "/"));
		if (_t2) {
			_t2 = new Date(_t2.replace("-", "/").replace("-", "/"));
		} else {
			_t2 = new Date();
		}

		var result = Date.parse(_t1) - Date.parse(_t2);

		if (result > 0) {
			return true;
		} else {
			return false;
		}
	}

	//获取客服
	var get_server_list = function() {
			var key = "base.info.get_user_server";

			var obj = localStorage.getItem(key);

			if (obj != null) {
				var json = JSON.parse(obj);

				if (compTime(json.Message)) {
					return json;
				}
			}

			mui.ajax(global.apiUrl + api.nbase.get_user_server, {
				headers: global.headers(),
				async: false,
				dataType: 'json',
				type: 'get',
				timeout: 6000,
				success: function(data) {

					if (data.ResultCode == 0) {
						obj = data;
						localStorage.setItem(key, JSON.stringify(obj));
					} else {
						mui.toast(data.Message);
					}

				},
				error: function(xhr, type, errorThrown) {

					mui.toast("当前网络不可用，请稍后再试~");
				}
			});
			return obj;
		}
		//获取服务价格参数信息
	var get_serverpice_config = function() {
		var confingjson = {};
		mui.ajax(global.apiUrl + api.base.get_confng, {
			headers: global.headers(),
			async: false,
			dataType: 'json',
			type: 'get',
			timeout: 6000,
			data: {
				"key": "Gtt.ServicePrice"
			},
			success: function(data) {
				confingjson = data.Data;
			}
		});
		return confingjson;
	}

	//获取等级白名单
	var get_level_whitelist = function() {
			var confingjson = {};
			mui.ajax(global.apiUrl + api.base.get_confng, {
				headers: global.headers(),
				async: false,
				dataType: 'json',
				type: 'get',
				timeout: 6000,
				data: {
					"key": "Gtt.LevelWhiteList"
				},
				success: function(data) {
					confingjson = data.Data;
				}
			});
			return confingjson;
		}
		//获取车站信息
	var get_site_source = function() {
		var key = "base.info.get_site_source";

		var obj = localStorage.getItem(key);

		if (obj != null) {
			var json = JSON.parse(obj);

			mui.ajax(global.apiUrl + api.nbase.get_site_source, {
				headers: global.headers(),
				dataType: 'json',
				type: 'get',
				timeout: 6000,
				success: function(data) {
					if (data.ResultCode == 0) {
						localStorage.setItem(key, JSON.stringify(data.Data));
					} else {
						mui.toast(data.Message);
					}

				},
				error: function(xhr, type, errorThrown) {

				}
			});
			return json;
		}
		var j = null;
		mui.ajax(global.apiUrl + api.nbase.get_site_source, {
			headers: global.headers(),
			async: false,
			dataType: 'json',
			type: 'get',
			timeout: 6000,
			success: function(data) {

				if (data.ResultCode == 0) {
					j = data.Data;

					localStorage.setItem(key, JSON.stringify(data.Data));
				} else {
					mui.toast(data.Message);
				}

			},
			error: function(xhr, type, errorThrown) {

				mui.toast("当前网络不可用，请稍后再试~");
			}
		});

		return j;

	}
	//方法再增加返回内容。不局限在城市了
	var getCityData = function(Refresh) {
		var key = "city_list_gtt";
		var async = false;
		if (!Refresh) {
			var city = localStorage.getItem(key);
			if (city) {
				return JSON.parse(city);
			}
		} else {
			async = true;
		}

		var json = null;
		mui.ajax(global.apiUrl + api.nbase.get_city_list, {
			headers: global.headers(),
			async: async,
			dataType: 'json',
			type: 'post',
			timeout: 60000,
			success: function(data) {

				if (data.ResultCode == 0) {
					json = data.Data.City;
					localStorage.setItem(key, JSON.stringify(json));
					localStorage.setItem("Gtt.GCodePrompt", data.Data.GCodePrompt);
					localStorage.setItem("Gtt.TicketsPrompt", data.Data.TicketsPrompt);
					localStorage.setItem("Gtt.AboutUS", data.Data.AboutUS);
					localStorage.setItem("Gtt.GivePackagesID", data.Data.GivePackagesID);
				} else {
					mui.toast(data.Message);
				}

			},
			error: function(xhr, type, errorThrown) {
				if (Refresh) //重写回退方法
				{
					mui.toast("当前网络不可用，请稍后再试~");
					hideSelf = function() {
						util.allInputBlur();
						util.close();
					}
				}
			}
		});
		return json;
	}

	var GetLevelSub = function(_item) {
			//_item 1：VIP购票，2：贵宾通道，3：贵宾车，4：陪护送
			this.LoginInfo = GetLogin();
			this.LevelSub = this.LoginInfo.LevelSub;
			for (i in this.LevelSub) {
				if (this.LevelSub[i].ServiceItems == _item) {
					return this.LevelSub[i];
				}
			}

			return {
				Cost1: 0,
				Cost2: 0,
				Cost3: 0,
				Cost4: 0,
				ConfigJson:""
			};
		}
		//获取套餐（_type:套餐类型）
	var GetMemberPackages = function(_type) {
		var LoginInfo = GetLogin();
		var MemberPackages = LoginInfo.MemberPackages;
		var newPackages = [];
		if (_type) {

			for (i in MemberPackages) {
				if (MemberPackages[i].FormType == _type) {
					newPackages.push(MemberPackages[i]);
				}
			}
			return newPackages;
		} else {

			return MemberPackages;
		}
	}
	 
	
	return {
		SaveLogin: SaveLogin, //保存信息
		GetLogin: GetLogin, //获取登录信息[返回JSON]
		GetLoginID: GetLoginID, //获取登录ID
		ExitLogin: ExitLogin, //退出
		getPaperworkType: getPaperworkType,
		showPicker: showPicker,
		get_server_list: get_server_list, //获取客服列表
		compTime: compTime,
		serverpice: get_serverpice_config,
		level_whitelist: get_level_whitelist,
		getCityData: getCityData,
		GetLevelSub: GetLevelSub,
		GetMemberPackages: GetMemberPackages,
		 
	}
})