define(['global', 'mui', 'config', 'base.info', 'api'], function(global, mui, config, info, api) {
	var initData = function(IsOpen, fn) {
			if(info.GetLoginID() == "") {
				if(IsOpen) {
					showWaiting("加载中...");

				}

				if(fn) {
					fn();
				}
				return;
			}

			//更新下一些数据
			var head = global.headers();
			head.IsLogin = 1; //预留，用来判断第一次打开应用
			if(IsOpen) {
				showWaiting("加载中...");
				//第一次打开时，先清掉
				info.ExitLogin();
			}

			//用户信息
			mui.ajax(global.apiUrl + api.member.get_member_info, {
				headers: head,
				data: {
					"": "{Field:'*'}"
				},
				dataType: 'json',
				type: 'post',

				timeout: config.timeout,
				success: function(data) {
					if(data.ResultCode == 99) {
						info.ExitLogin();
					}
					if(data.ResultCode == 0) {
						info.SaveLogin(data.Data);

					}
					if(fn) {
						fn(IsOpen);
					}

				},
				error: function(xhr, type, errorThrown) {
					if(fn) {
						fn(IsOpen);
					}
				}
			});
		}
		//错误提交（错误类型，错误内容）
	var submitError = function(_c) {

		mui.ajax(global.apiUrl + api.nbase.submit_error, {
			headers: head,
			data: {
				"": JSON.stringify(_c)
			},
			dataType: 'json',
			type: 'post',

			timeout: config.timeout,
			success: function(data) {

			},
			error: function(xhr, type, errorThrown) {

			}
		});
	}

	function isChn(str) {
		var reg = /^[0-9A-Za-z]+$/;
		if(reg.test(str)) {
			return true;
		}
		return false;
	}
	//创建上传对象
	var upload = function(_s) {
			var timestamp = new Date().getTime().toString();
			var up = plus.uploader.createUpload(global.apiUrl + api.base.upload_pic, {
				method: "post",
			}, _s)
			up.setRequestHeader("wow-appkey", global.appKey);
			up.setRequestHeader("wow-timestamp", timestamp);
			up.setRequestHeader("wow-secret", global.appSecret);
			up.setRequestHeader("wow-sign", md5(global.appKey + global.appSecret + timestamp));
			up.setRequestHeader("wow-uid", localStorage.getItem(global.ID) ? localStorage.getItem(global.ID) : '');
			up.setRequestHeader("wow-version", localStorage.getItem("inf.version"));
			up.addData("id", localStorage.getItem(global.ID))
			return up;
		}
		//获取元素在在数组中的索引
	var getIndex = function(array, item) {
		for(var i = 0; i < array.length; i++) {
			if(array[i] == item) return i;
		}
	};
	//判断元素是否在数组中
	var inArray = function(arrarObj, element) {
		for(var i = 0; i < arrarObj.length; i++) {
			if(arrarObj[i] == element) return true;
		}
		return false;
	};
	//判断是不是数字
	function isInt(str) {
		var reg = /^(-|\+)?\d+$/;
		return reg.test(str);
	}
	//去掉前后空格
	var trim = function(str) {
		return str.replace(/(^\s*)|(\s*$)/g, "");
	};
	//验证数据是否为null值
	var isNull = function(str) {
		if(!str) return true;
		var s = trim(str);
		return s.length == 0;
	};
	//显示对象
	var showObj = function(_o) {
			if(typeof _o == "string") {
				_o = document.querySelector(_o);
			}
			if(_o.toString() == "[object NodeList]") {
				for(var i = 0; i < _o.length; i++) {
					console.log(_o[i]);
					_o[i].style.display = "";
					_o[i].style.opacity = 1;
				}
				return;
			}
			_o.style.display = "";
			_o.style.opacity = 1;
		}
		//隐藏对象
	var hideObj = function(_o) {
		if(typeof _o == "string") {
			_o = document.querySelector(_o);
		}
		if(_o.toString() == "[object NodeList]") {
			for(var i = 0; i < _o.length; i++) {
				_o[i].style.display = "none";
			}
			return;
		}
		_o.style.opacity = 0;
		setTimeout(function() {
			_o.style.display = "none";
		}, 300);
	}

	var delay = function(fn) {
		setTimeout(fn, 50);
	};
	//简单的JSON合并-把后一个向前合并(以后推荐用MUI的http://dev.dcloud.net.cn/mui/util/#extend)
	function extend(json1, json2) {
		for(i in json2) {
			json1[i] = json2[i];
		}
		return json1;
	}
	//不传参数时只用于预加载页面
	var show = function(self) {
			closeWaiting();
			if(self == null) {
				self = plus.webview.currentWebview();

				var pself = plus.webview.getWebviewById(self.id + "p");

				if(pself) {

					if(!pself.preload) {
						return;
					}
					self = pself; //如果父窗口存在时，则显示父窗口
				}
			}

			self.show("slide-in-right", 200);
		}
		//打开新窗口
		//_e:{gttUrl:地址,Title:标题,new:提供该参数将会是新页面打开,webview:1=非父子页面模板} 
		//isLogin:是否需要判断登录
		//style:样式
	var openNewWinSub = function(_e, isLogin, style) {

		if(isLogin != null && isLogin == 1) {
			if(info.GetLoginID() == "") {
				openNewWinSub({
					gttUrl: "../main/login.html",
					gttTitle: "登录"
				});
				return;
			}
		}
		if(isNull(_e.gttUrl)) {
			mui.toast('打开失败，传入地址为空');
			return;
		}
		var subpageStyle = {
			top: '0px',
			bottom: '0px',
			render: 'always',
			hardwareAccelerated: true,
			scrollIndicator: "none"
		};
		if(style) {
			extend(subpageStyle, style) // 样式合并
		}
		var self = plus.webview.currentWebview();
		//传递参数合并
		var extras = {
			pid: self.id, //打开页面的ID
			ppid: _e.gttUrl + "p", //html.html的ID
			init: "init"
		};
		if(_e) {
			extend(extras, _e) //传递参数合并
		}
		var show = {
			autoShow: false, //页面loaded事件发生后自动显示，默认为true
			duration: 200
		}
		if(_e.gttUrl == "../main/login.html") {
			show = {
				autoShow: false, //页面loaded事件发生后自动显示，默认为true
				duration: 300,
				aniShow: "slide-in-bottom", //页面显示动画，默认为”slide-in-right“；
			}
		}
		var urlHtml = "../main/Html.html"; //父子页模板，解决IOS会把输入框顶到顶部
		var idHtml = "../main/Html.html";

		if(_e.new) //判断是否以新页面打开
		{
			idHtml = _e.gttUrl + "p";
		} else {
			//
			extras.IsHtml = 1;

			if(_e.webview == 1) {
				//整体窗口形式打开
				urlHtml = _e.gttUrl;
				idHtml = "null.html";

				var wvHtml = plus.webview.getWebviewById(idHtml);

				if(wvHtml) {
					var getUrl = localStorage.getItem("UrlBack");
					localStorage.setItem("UrlBack", urlHtml);

					if(getUrl == urlHtml) {

						wvHtml.show("slide-in-right", 250);
						return;
					}

					wvHtml.loadURL(urlHtml);
					wvHtml.show("auto");
					return;
				}

				localStorage.setItem("UrlBack", urlHtml);
			} else {
				//父子页面模板
				var wvHtml = plus.webview.getWebviewById(idHtml);
				if(wvHtml) {
					mui.fire(wvHtml, "init", _e);

					setTimeout(function() {
						wvHtml.show("auto");
					}, 100);

					return;
				}
			}

		}
		var wvMuBan = plus.webview.create(urlHtml, idHtml, subpageStyle, extras);
		wvMuBan.show("slide-in-right");

	};
	//打开新窗口-预加载模式（地址，是否需要判断登录，样式，扩展参数,是否预加载模式(默认关闭)）
	var openNewWin = function(url, isLogin, style, _e, preload) {

		if(isLogin != null && isLogin == 1) {
			if(info.GetLoginID() == "") {

				openNewWinSub({
					gttUrl: "../main/login.html",
					gttTitle: "登录"
				});
				return;
			}
		}
		if(isNull(url)) {
			mui.toast('打开失败，传入地址为空');
			return;
		}
		var subpageStyle = {
			top: '0px',
			bottom: '0px',
			render: 'always',
			hardwareAccelerated: true
		};
		if(style) {
			extend(subpageStyle, style)
		}
		var self = plus.webview.currentWebview();
		var extras = {
			pid: self.id,
			init: "init"
		};
		if(_e) {
			extend(extras, _e)
		}

		if(preload == true) {
			//预加载模式
			extras.preload = true;
			url = trim(url);
			showWaiting();
			var subWebView = plus.webview.create(url, url, subpageStyle, extras);

		} else {
			mui.openWindow({
				url: url,
				id: url,
				styles: subpageStyle,
				extras: extras,
				show: {
					autoShow: true, //页面loaded事件发生后自动显示，默认为true
					duration: 200
				},
				createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
				waiting: {
					autoShow: false, //自动显示等待框，默认为true
					title: '努力加载中...', //等待对话框上显示的提示内容
					options: {
						back: "none",
						width: "130px",
						background: "rgba(0,0,0,0.5)"
					}
				}
			});
		}

	};
	//打开子窗口
	var openNewSub = function(url, style, isLogin) {
		if(isLogin != null && isLogin == 1) {
			if(info.GetLoginID() == "") {
				openNewWinSub({
					gttUrl: "../main/login.html",
					gttTitle: "登录"
				});
				return;
			}
		}
		if(isNull(url)) {
			mui.toast('打开失败，传入地址为空');
			return;
		}
		var subpageStyle = {
			top: '0px',
			bottom: '0px',
			render: 'always',
			hardwareAccelerated: true
		};
		if(style) {
			extend(subpageStyle, style)
		}
		url = trim(url);
		var self = plus.webview.currentWebview();
		self.append(plus.webview.create(url, url, subpageStyle));

	};
	var floatw = null;
	//打开窗口添加遮罩层
	var floatWebview = function(url, style) {
			if(info.GetLoginID() == "") {
				openNewWinSub({
					gttUrl: "../main/login.html",
					gttTitle: "登录"
				});
				return;
			}
			//避免快速多次点击创建多个窗口
			if(floatw) {
				return;
			}
			var wv = plus.webview.getWebviewById(url);
			if(wv) {
				wv.show("auto", 300);
				return;
			}
			// 创建悬浮窗口

			var s = {
				width: '200px',
				height: '200px',
				margin: "auto",
				background: "rgba(0,0,0,0.5)",
				scrollIndicator: 'none',
				scalable: false,
				popGesture: 'none'
			}
			if(style) {
				mui.extend(s, style);
			}
			floatw = plus.webview.create(url, url, s);
			floatw.addEventListener("loaded", function() {
				floatw.show("slide-in-bottom")
				floatw = null;
			}, false);

		}
		//拨打电话
	function call(tel) {
		if(isNull(tel)) {
			mui.toast("拨打失败，电话号码没有");
			return;
		}
		mui.confirm("立即拨打电话：" + tel, "客服电话", function(e) {
			if(e.index == 0) {
				//						// 导入Activity、Intent类
				//						var Intent = plus.android.importClass("android.content.Intent");
				//						var Uri = plus.android.importClass("android.net.Uri");
				//						// 获取主Activity对象的实例
				//						var main = plus.android.runtimeMainActivity();
				//						// 创建Intent
				//						var uri = Uri.parse("tel:" + tel);
				//						var call = new Intent("android.intent.action.CALL", uri);
				//						// 调用startActivity方法拨打电话
				//						main.startActivity(call);
				plus.device.dial(tel, true);
			} else {
				//info.innerText = 'MUI没有得到你的认可，继续加油'
			}
		});

	};

	//选中/不选中
	var divselect = function(obj, class_name) {

		var arry = obj.className.split(" ");

		var status = inArray(arry, class_name);

		if(!status) {
			var alreadySelectClass = mui("." + class_name)[0];
			var alreadySelectClassaArry = alreadySelectClass.className.split(" ");
			var index = getIndex(alreadySelectClassaArry, class_name);
			alreadySelectClassaArry.splice(index, 1);
			alreadySelectClass.className = arry.join(" ");
			var newstatus = obj.className + " " + class_name;
			obj.className = newstatus;
		}
		return obj;
	};
	//关闭当前窗口！ 
	var close = function(_time) {
			var s = plus.webview.currentWebview();

			var p = s.parent();

			if(p) {
				s = p;
			}

			if(!_time && _time != 0) {
				_time = 300;
			}
			
			s.setStyle({
				zindex: -999
			});
			s.close("auto", _time);
		}
		//把表单的值全部获取
	var getForm = function(form) {
			var o = {};
			form.each(function() {
				if(o[this["name"]]) {
					o[this["name"]] = o[this["name"]] + "," + this["value"]
				} else {
					o[this["name"]] = this["value"]
				}
			});

			return o;
		}
		//发送验证码，自动计时
	var aotuTime = function(_this, _time) {
		_this.disabled = true;
		//自动倒计时
		_this.innerHTML = _time + "秒后再次";
		if(_time == 0 || _time == null) {
			_this.disabled = false;
			_this.innerHTML = "获取验证码";
			return;
		}
		setTimeout(function() {
			aotuTime(_this, _time - 1)
		}, 1000)
	}
	var showWaiting = function(_showInfo) {
		if(!_showInfo) {
			_showInfo = "正在加载中...";
		}
		plus.nativeUI.showWaiting(_showInfo, {
			back: "none",
			width: "130px",
			background: "rgba(0,0,0,0.5)"
		});
	}
	var closeWaiting = function() {
		plus.nativeUI.closeWaiting();
	}
	var allInputBlur = function() {
			mui("input").each(function() {
				this.blur();
			})
		}
		//调用父窗口事件(事件名称，扩展参数,需要执行的窗口ID)
	var pInit = function(_pevent, _e, _pid) {
			var self = plus.webview.currentWebview();
			if(!_pid) {
				_pid = self.pid;
			}
			var pself = plus.webview.getWebviewById(_pid);
			if(_pevent) {
				mui.fire(pself, _pevent, _e);
			} else {
				//调用事件默认事件
				mui.fire(pself, self.gttInit);
				if(self.pid == "../member/setting.html") {
					var member = plus.webview.getWebviewById("../member/index.html");
					if(member) {
						mui.fire(member, "init");
					}
				}
			}

		}
		//比较两个时间大小。
		//_t1 = 时间
		//_t2 = 时间2（不传入时则获取当前时间）
		//_t1 > _t2 时 则返回 true
	var compTime = function(_t1, _t2) {
		_t1 = new Date(_t1.replace("-", "/").replace("-", "/"));
		if(_t2) {
			_t2 = new Date(_t2.replace("-", "/").replace("-", "/"));
		} else {
			_t2 = new Date();
		}

		var result = Date.parse(_t1) - Date.parse(_t2);

		if(result > 0) {
			return true;
		} else {
			return false;
		}
	}
	var exitApp = function() {
			var exitApp_first = null;
			mui.back = function() {

				//首次按键，提示‘再按一次退出应用’
				if(!exitApp_first) {
					exitApp_first = new Date().getTime();
					mui.toast('再按一次退出应用');
					setTimeout(function() {
						exitApp_first = null;
					}, 1000);
				} else {
					if(new Date().getTime() - exitApp_first < 1000) {

						plus.nativeUI.confirm("是否立即退出应用？", function(event) {
							if(0 == event.index) {
								plus.runtime.quit();
							}
						}, '退出提醒', ["立即退出", "取消"]);

					}
				}

			};
		}
		//从数组中取出Text
	var getListText = function(_data, _value) {
			for(i in _data) {
				if(_data[i].value == _value) {
					return _data[i].text;
				}
			}
			return "";
		}
		//参数：链接，提交的参数，成功时执行方法，是否异步（false=同步）
	var ajax = function(url, data, success, async) {

		showWaiting();

		mui.ajax(url, {
			headers: global.headers(),
			async: async,
			data: data,
			dataType: 'json',
			type: 'post',
			timeout: config.timeout,
			success: function(data) {
				closeWaiting();
				if(data.ResultCode == 99) {
					mui.toast(data.Message);
					setTimeout(function() {
						openNewWin("../main/login.html", 0, null, {
							ispwd: 1
						});
					}, 500);

					return;
				}
				if(data.ResultCode == 0) {
					success(data);
				} else {
					mui.toast(data.Message);
				}

			},
			error: function(xhr, type, errorThrown) {
				closeWaiting();
				mui.toast("当前网络不可用，请稍后再试~");
			}
		});

	}
	var setDate = function(d) {
			var h = d.getHours();
			if(h == 23) {
				d.setDate(d.getDate() + 1);
			}
			var day = d.getDay();
			var dayformat = "";
			switch(day) {
				case 0:
					dayformat = "星期日";
					break;
				case 1:
					dayformat = "星期一";
					break;
				case 2:
					dayformat = "星期二";
					break;
				case 3:
					dayformat = "星期三";
					break;
				case 4:
					dayformat = "星期四";
					break;
				case 5:
					dayformat = "星期五";
					break;
				case 6:
					dayformat = "星期六";
					break;
			}

			var datetext = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + "   " + dayformat;
			mui("#item_startdate_value")[0].innerText = datetext;
			mui("#DepartureDate")[0].value = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate();
			var obj = mui("#item_starttime_value");
			if(obj.length > 0) {
				if(h == 23 || h < 6) {
					obj[0].innerText = "6:00-7:00"
				} else {
					obj[0].innerText = (h + 1) + ":00-" + (h + 2) + ":00"
				}
			}

		}
		//选择日期时的判断
	var selectDate = function(rs) {
			var strDate = rs.text.replace(/-/g, "/");

			var date = new Date(strDate);
			if(mui("#item_starttime_value").length > 0) {
				var time = mui("#item_starttime_value")[0].innerText;
				time = time.substring(0, time.indexOf(":"));
				date.setHours(Number(time) - 1);
				date.setMinutes(59);
				date.setSeconds(59);
			} else {
				date.setHours(new Date().getHours() + 1);
			}
			var nowDate = new Date();
			if(date.getTime() > nowDate.getTime()) {
				setDate(date);
			} else {
				mui.alert("不能选择小于当前时间的日期~");
				return false;
			}
		}
		//选择时段时判断
	var selectTime = function(items) {
		if(items[0]) {
			var str = mui("#DepartureDate")[0].value.replace(/-/g, "/");

			var time = items[0].text;
			time = time.substring(0, time.indexOf(":"));

			var date = new Date(str);
			date.setHours(Number(time));
			date.setMinutes(0);
			date.setSeconds(0);
			var nowDate = new Date();
			if(date.getTime() > nowDate.getTime()) {
				mui("#item_starttime_value")[0].innerText = items[0].text;
			} else {
				mui.alert("不能选择小于当前时间的时段~");
				return false;
			}
		} else {
			return false;
		}
	}
	var sharewx = null; //分享微信对象
	//显示分享菜单
	var showShareSheet = function() {
			if(info.GetLoginID() == "") {
				openNewWinSub({
					gttUrl: "../main/login.html",
					gttTitle: "登录"
				});
				return;
			}
			//获取分享服务
			plus.share.getServices(function(s) {

				for(var i in s) {
					if('weixin' == s[i].id) {
						sharewx = s[i];
					}
				}
			}, function(e) {
				//失败
			});
			//{title:"发送给微信好友"},{title:"分享到微信朋友圈"},
			//				case 1:
			//								WXShare("WXSceneSession");
			//							break;
			//							case 2:
			//								WXShare("WXSceneTimeline");
			//							break;
			var bts = [{
				title: "仅复制邀请码"
			}];
			plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: bts
				},
				function(e) {
					var i = e.index;
					switch(i) {

						case 1:
							showinvitecode();
							break;
					}
				}
			);
		}
		//微信分享地址
	var WXShare = function(scene) {
			var member = info.GetLogin();
			sharewx.send({
				content: "注册高铁通-填邀请码：" + member.InvitationCode,
				title: "高铁通，您的出行之旅~",
				href: "http://www.gttvip.cn?code=" + member.InvitationCode,
				thumbs: ["http://h5.gttvip.cn/Areas/App/Content/180x180.png"],
				pictures: ["http://h5.gttvip.cn/Areas/App/Content/180x180.png"],
				extra: {
					scene: scene
				}
			}, function() {
				mui.toast("分享成功！");
			}, function(e) {

			});
		}
		//显示邀请码弹窗
	var showinvitecode = function() {
		var member = info.GetLogin();
		if(member == null) {
			return;
		}
		var btnArray = ['复制', '取消'];
		mui.confirm('请点击复制按钮', '您的邀请码为：' + member.InvitationCode, btnArray, function(e) {
			if(e.index == 0) {
				var os = plus.os.name; //'iOS','Android'
				if(os == 'iOS') {
					var UIPasteboard = plus.ios.importClass("UIPasteboard");
					//这步会有异常因为UIPasteboard是不允许init的，init的问题会在新版中修改
					var generalPasteboard = UIPasteboard.generalPasteboard();
					// 设置/获取文本内容:
					generalPasteboard.setValueforPasteboardType(member.InvitationCode, "public.utf8-plain-text");
					var value = generalPasteboard.valueForPasteboardType("public.utf8-plain-text");
					mui.toast("已将邀请码复制到您的剪切板！");
				}
				if(os == 'Android') {
					var Context = plus.android.importClass("android.content.Context");
					var main = plus.android.runtimeMainActivity();
					var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
					plus.android.invoke(clip, "setText", member.InvitationCode);
					mui.toast("已将邀请码复制到您的剪切板！");
				}
			} else {
				//info.innerText = 'MUI没有得到你的认可，继续加油'
			}
		});
	}

	function getQueryString(name) {
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
		var r = window.location.search.substr(1).match(reg);
		if(r != null) return unescape(r[2]);
		return null;
	}
	//隐藏父子模板
	function hideWebview(isReload) {

		var self = plus.webview.currentWebview();
		if(isReload) {
			self.parent().hide("auto");
			self.hide("none", 0);

//			setTimeout(function() {
//				self.reload();
//			}, 1000);
		} else {
			self.parent().hide("none");
			self.hide("none", 0);
		}

	}

	// 
	function objBlur() {

	}
	//_tags dom集合，根据ID作为key，取JSON数据赋值
	var JsonToTag = function(_tags, _json) {
		if(!_json) {
			return;
		}
		for(var i = 0; i < _tags.length; i++) {
			if(_tags[i]) {

				var key = _tags[i].getAttribute("name") ? _tags[i].getAttribute("name") : _tags[i].getAttribute("id")
				if(_json[key]) {
					if(_tags[i].tagName == "INPUT") {
						_tags[i].value = _json[key];
					} else {
						_tags[i].innerHTML = _json[key];
					}
				}
			}

		}
	}

	//选中select 标签
	var selectOption = function(doc, value) {
			for(var i = 0; i < doc.options.length; i++) {
				var v = doc.options[i].value;
				if(v == value) {
					doc.options[i].selected = true;
					return;
				}
			}
		}
		//checkbox radio
	var inputCheck = function(doc, value) {
		var vList = value.split(","); //英文字符
		for(var l = 0; l < doc.length; l++) {
			doc[l].checked = false;
			for(var i = 0; i < vList.length; i++) {
				if(doc[l].value == vList[i]) {
					doc[l].checked = true;
				}
			}
		}
	}

	var PwdVerify = function(_pwd, _fn) {
		if(!_pwd) {
			if(_fn) {
				_fn();
			}
			return "请输入密码~";
		}
		_pwd = trim(_pwd);
		if(_pwd.length < 8 || _pwd.length > 16) {
			if(_fn) {
				_fn();
			}
			return "密码长度请控制在：8-16位~";
		}

		var reg = /(^([a-zA-Z]+[0-9]+)$)|(^[0-9]+[a-zA-Z]+$)/;
		var m = reg.test(_pwd);
		if(!m) {
			return "不可使用特殊字符、纯英文或纯数字密码。";
		}

		return null;
	}

	//JSON数据绑定实例格式：
	//	jsonBind({data:{
	//		title:"这是两个标题",
	//		name:"这是三个名称",
	//		input:"怎么的，就是input",
	//		select:"1",
	//		checkbox:"2,3",
	//		radio:"2"
	//	},list:json});
	//{className:数据源}  
	//当数据源是数组时，则自动判断为列表循环 {{fn function 参数（参数可以多个，空格隔开）}}  {{text 文本输出的格式}}
	//列表时在  checkbox radio select 等特殊标签时没法做好展示，请在外部输成字符串穿入再替换 
	var jsonBind = function(_json) {
		for(var key in _json) {
			var dataJson = _json[key];
			if(!dataJson) {
				continue;
			}
			if(dataJson.length) {

				var doc = document.querySelector("." + key);
				if(!doc) {
					console.log("错误，模板页没找到~");
					return;
				}
				doc.style.display = "none"; //把模板自己隐藏了;
				var docHtml = doc.innerHTML;
				var jsonLength = dataJson.length;
				for(var i = 0; i < jsonLength; i++) {
					var subHtml = docHtml;
					var div = document.createElement(doc.nodeName);
					div.className = doc.className;
					//赋予属性
					for(var s = 0; s < doc.attributes.length; s++) {
						if(doc.attributes[s].name.indexOf("data-") > -1) {
							var key = doc.attributes[s].name.substring(5);
							var v = dataJson[i][key];
							if(v) {
								div.setAttribute(doc.attributes[s].name, dataJson[i][key]);
							}
						}
					}

					var fnReg = new RegExp("({{fn\\s)([\\d\\w\\s\\u4e00-\\u9fa5]+)(}})", "gi");
					//执行函数部分
					while(arr = fnReg.exec(subHtml)) {

						var fnStr = arr[2].split(" ");
						var fn = ""; //组成执行函数
						for(var f = 1; f < fnStr.length; f++) {

							var jsonKey = fnStr[f];

							if(jsonKey && jsonKey.length > 0 && jsonKey != " ") {
								if(fn) {
									fn += ",";
								}
								var v = dataJson[i][jsonKey]
								if(v && typeof(v) == "string") {
									v = v.replace(/\"/g, "\\\"");
								}

								fn += '"' + v + '"';
							}

						}
						var fnReg2 = new RegExp(arr[0], "g");

						fn = eval(fnStr[0] + "(" + fn + ")");
						subHtml = subHtml.replace(fnReg2, fn);
					}
					//text的输出文本
					fnReg = new RegExp("({{text\\s)([\\d\\w\\s\\u4e00-\\u9fa5]+)(}})", "gi");
					while(arr = fnReg.exec(subHtml)) {

						var fnStr = arr[2];

						var fnReg2 = new RegExp(arr[0], "g");
						var v = dataJson[i][fnStr];
						if(v) {
							v = v.replace(/</g, "&lt;").replace(/>/g, "&gt;");
						}

						subHtml = subHtml.replace(fnReg2, v);
					}

					var strReg = new RegExp("{{([\\d\\w\\s\\u4e00-\\u9fa5]+)}}", "gi");
					var strMatch = subHtml.match(strReg);
					//字符直接替换部分
					for(key in strMatch) {
						if(key) {
							var keyStr = strMatch[key];

							var v = dataJson[i][keyStr.substr(2, keyStr.length - 4)];
							var reg = new RegExp(keyStr, "gi");
							subHtml = subHtml.replace(reg, v);
						}
					}

					div.innerHTML = subHtml;
					doc.parentNode.appendChild(div);
				}

			} else {
				var docList = document.querySelectorAll("." + key);
				var docListLength = docList.length;
				for(var i = 0; i < docListLength; i++) {

					var docName = docList[i].getAttribute("name");
					var v = dataJson[docName];
					if(!v) {
						continue;
					}

					switch(docList[i].nodeName.toLowerCase()) {
						case "select":
							selectOption(docList[i], v);
							break;
						case "input":

							if(docList[i].type.toLowerCase() == "checkbox" || docList[i].type.toLowerCase() == "radio") {
								var inputList = document.querySelectorAll("input[name='" + docName + "']");
								inputCheck(inputList, v);
							} else {
								docList[i].setAttribute("value", v);
							}

							break;
						default:
							docList[i].innerText = v;
							break;
					}

				}
			}
		}
	}

	//套餐选择专用 _formtype = 套餐类型，_fn = 成功选择时  
	var mpList = function(_formtype, _fn) {
		var MemberPackages = info.GetLogin().MemberPackages;
		var mpCount = 0;
		var currMp = 0; //当前类型套餐计数
		var list = document.querySelector("#pList");

		var mpID = getQueryString("mpid");
		var selectPackage = document.querySelector("#selectPackage");
		var MemberPackagesID = document.querySelector("#MemberPackagesID");

		for(var i in MemberPackages) {
			if(MemberPackages[i].FormType == 1 || (MemberPackages[i].FormType == 3 && _formtype != 4) || MemberPackages[i].FormType == 4 && _formtype != 3) {
				if(MemberPackages[i].FormType == _formtype) {
					currMp += 1;
				}
				if(mpID == MemberPackages[i].ID) {
					selectPackage.innerHTML = MemberPackages[i].Name + "(剩余<span style='color:red;'>" + MemberPackages[i].SurplusCount + "</span>次)";
					MemberPackagesID.value = MemberPackages[i].ID;
					if(_fn) {
						_fn(MemberPackages[i].ID);
					}
				}
				mpCount += 1;
				var li = document.createElement("li");
				li.className = "mui-table-view-cell mui-media";
				li.setAttribute("packageid", MemberPackages[i].ID);
				li.setAttribute("FormType", MemberPackages[i].FormType);
				var html = '<img src="../../images/car.png" class="mui-media-object mui-pull-left">' +
					'<div class="mui-media-body mui-navigate-right">' +
					'<p>' +
					'<span class="span_1" style="color:#666666;font-size: 14px;" >' + MemberPackages[i].Name + '(<span class="span_3">剩余<span style="color:red;">' + MemberPackages[i].SurplusCount + '</span>次)</span>' +
					'</p>' +
					'<p><span class="span_2">套餐类型：' + MemberPackages[i].FormTypeDes + '</span></p>' +
					'<p><span class="span_2">结束日期：' + MemberPackages[i].EndTime + '</span></p>' +
					'</div>';
				li.innerHTML = html;
				list.appendChild(li);
			}
		}
		var hideTc = function() {
			document.querySelector("#selectPackage").innerHTML = "不使用套餐";
			document.querySelector("#MemberPackagesID").value = "";
			if(_fn) {
				_fn(null);
			}
			mui('#topPopover').popover('hide');
		}
		document.querySelector("#tcClose").addEventListener("tap", function() {
			hideTc();
		})
		if(mpCount > 0) {
			if(!MemberPackagesID.value) {
				selectPackage.value = "不使用套餐";
			}
			//套餐切换tap事件
			mui("#pList").on("tap", ".mui-media", function() {
				var FormType = this.getAttribute("FormType");
				var _mpid = this.getAttribute("packageid");
				if(!_mpid) {
					document.querySelector("#selectPackage").innerHTML = "不使用套餐";
					document.querySelector("#MemberPackagesID").value = "";
					 
					if(_fn) {
						_fn(_mpid);
					}
					mui('#topPopover').popover('hide');
					return;
				}
				if(FormType == _formtype) {
					if(_mpid) {
						document.querySelector("#selectPackage").innerHTML = this.querySelector(".span_1").innerHTML;
						document.querySelector("#MemberPackagesID").value = _mpid;
					}else{
						document.querySelector("#MemberPackagesID").value = "";
					}
					mui('#topPopover').popover('hide');
					if(_fn) {
						_fn(_mpid);
					}
					 
				} else {

					if(FormType == 1) {
						//贵宾通道+贵宾车
						openNewWinSub({
							gttUrl: "../packages/gbtd_phs.html?mpid=" + _mpid,
							gttTitle: "套餐下单",
							preload: false,
						}, 1);
					}
					if(FormType == 3) {

						//贵宾通道
						openNewWinSub({
							gttUrl: "../vippassage/index.html?mpid=" + _mpid,
							gttTitle: "贵宾通道",
							preload: false,
						}, 1);
					}
					if(FormType == 4) {

						//贵宾车
						openNewWinSub({
							gttUrl: "../vipcar/index.html?mpid=" + _mpid,
							gttTitle: "贵宾车",
							preload: false,
						}, 1);
					}
				}

			});
			document.querySelector("#atopPopover").addEventListener("tap", function() {
				mui('#topPopover').popover('toggle');
			});
			//套餐切换
			mui('.mui-scroll-wrapper').scroll();
			var hide = getQueryString("hide");
			if(hide) {
				document.querySelector("#selectPackage").innerHTML = "不使用套餐";
				document.querySelector("#MemberPackagesID").value = "";
				if(_fn) {
					_fn(null);
				}
			} else {
				if(_formtype != 1 && !mpID) {
					mui('#topPopover').popover('show');
				}
			}

		} else {
			selectPackage.innerHTML = "没有套餐";
			MemberPackagesID.value = "";
			document.querySelector("#SwitchPackage").style.display = "none"; //隐藏
		}
	}

	//获取菜单
	var getMenuList = function(_TimeStamp) {
			if(!_TimeStamp) {
				_TimeStamp = "";
			}
			//自己获取
			mui.ajax(global.apiUrl + api.nbase.get_menu_list + "?ts=" + _TimeStamp, {
				headers: global.headers(),
				dataType: 'json',
				type: 'get',
				timeout: config.timeout,
				success: function(data) {
					if(data.ResultCode == 0) {
						localStorage.setItem("menber_menu_list", JSON.stringify(data.Data));
						CreateMenu(data.Data,true);
					}
				}
			});
		}
	//个人中心创建菜单
	var CreateMenu = function(_json,isTrue) {
		if (!isTrue){
			getMenuList(_json.TimeStamp)
		}
		var html = "";
		for(var i in _json.List) {
			if(compTime(_json.List[i].EndTime)) {
				html += '<li class="mui-table-view-cell me-li-oper wow-action" data-action="'+( _json.List[i].Url.indexOf("http") > -1 ? 'a' : "onw")+'" data-url="' + _json.List[i].Url + '" data-title="' + _json.List[i].Title + '" >';

				html += '<img src="' + (_json.List[i].Icon ? _json.List[i].Icon : "../../images/member/icon-03.png") + '" />';

				html += '<span class="mui-navigate-right">' + _json.List[i].Name + '</span></li>';
			}
			
		}
		
		document.querySelector("#menuList").innerHTML = html;
	}

	return {
		initData: initData,
		submitError: submitError, //错误提交
		isChn: isChn,
		upload: upload, //文件上传对象
		getIndex: getIndex,
		inArray: inArray,
		isInt: isInt,
		trim: trim,
		isNull: isNull,
		showObj: showObj,
		hideObj: hideObj,
		delay: delay,
		extend: extend,
		onw: openNewWin, //打开新窗口（地址，是否需要判断登录，样式，扩展参数,预加载模式(默认关闭)）
		ons: openNewSub,
		onws: openNewWinSub, //打开新窗口子窗口模式预加载模式(默认关闭)（扩展参数(gttUrl,Title 必填 gttData=传给子页面的参数。存JSON字符串，在传给子页面时会自动转换成JSON)，是否需要判断登录，样式）
		floatWebview: floatWebview,
		call: call,
		dselect: divselect,
		close: close,
		getForm: getForm,
		aotuTime: aotuTime,
		showWaiting: showWaiting,
		closeWaiting: closeWaiting,
		allInputBlur: allInputBlur,
		pInit: pInit,
		compTime: compTime, //比较两个时间大小
		exitApp: exitApp, //改写BACK 按两次返回退出APP
		getListText: getListText, //获取Text显示。
		ajax: ajax,
		show: show, //参数为窗口对象，不传入时则默认显示当前窗口
		setDate: setDate,
		selectDate: selectDate,
		selectTime: selectTime,
		showShareSheet: showShareSheet, //显示分享菜单
		getQueryString: getQueryString, //获取URL参数
		hideWebview: hideWebview,
		objBlur: objBlur,
		JsonToTag: JsonToTag,
		selectOption: selectOption,
		inputCheck: inputCheck,
		PwdVerify: PwdVerify,
		jsonBind: jsonBind,
		mpList: mpList,
		getMenuList: getMenuList,
		CreateMenu : CreateMenu
	}
})